void() spire_fall = {
};

void() spire_stand = {
AdvanceThinkTime(self,0.1);
self.think = SUB_Remove;
};

void() rise_timer = {
if (self.ltime>0) {
self.ltime -= 1;
self.think = SUB_Remove;
self.nextthink = (time + 0.02);
} else {
self.think = SUB_Remove;
self.nextthink = (time + 0.02);
}
};

void() rise_touch = {
if (other.takedamage == DAMAGE_YES) {
sound ( self, CHAN_VOICE, "weapons/gauntht1.wav", 1.00000, ATTN_NORM);

if (other.thingtype == THINGTYPE_FLESH) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 140.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_GREYSTONE) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 255.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_WOOD) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 85.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_CLOTH) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 255.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_BROWNSTONE) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 85.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_CLAY) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 85.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_ICE) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 249.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_GLASS) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 255.00000, 17, 80.00000);
}
if (other.thingtype == THINGTYPE_HAY) {
   particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 85.00000, 17, 80.00000);
}

if (self.owner.classname == "player") {
T_Damage ( other, self, self.owner, (self.owner.owner.level * 12));
} else {
T_Damage ( other, self, self.owner, 200);
}
} else {
sound (self, CHAN_VOICE, "misc/tink.wav", 1, ATTN_NORM);
self.think = rise_timer;
self.nextthink = (time + 0.1);
}
self.think = rise_timer;
self.nextthink = (time + 0.1);
};

void(entity risey) spire_rise = {
newmis = spawn();
newmis.owner = self;
newmis.solid = SOLID_PHASE;
newmis.movetype = MOVETYPE_FLY;

setorigin (newmis, (risey.origin + '0 0 0'));
newmis.size = ('2 2 0');
newmis.velocity = ('0 0 500');
newmis.speed = 10;
newmis.angles = vectoangles(newmis.velocity);
newmis.classname = "newmis";
newmis.ltime = 50;
newmis.touch = rise_touch;
// setmodel (newmis, "models/glowball.mdl");
newmis.think = rise_timer;
newmis.nextthink = (time + 0.01);
};

.float upper;

void() hold_timer = {
if (self.ltime>0) {
self.ltime -= 1;
if (self.frame > 6) {
self.upper = 0;
}
if (self.upper == 1) {
self.frame = (self.frame + 1);
} else {
self.frame = (self.frame - 1);
}
self.think = hold_timer;
self.nextthink = (time + 0.02);
if (self.frame == 7) {
self.nextthink = (time + 1);
}
} else {
self.think = SUB_Remove;
self.nextthink = (time + 0.02);
}
};

void (entity holdee) hold = {
newmis = spawn();
newmis.owner = self;
newmis.solid = SOLID_BBOX;
newmis.movetype = MOVETYPE_FLY;
newmis.upper = 1;
if ((holdee.thingtype == THINGTYPE_FLESH) && (self.classname != "flare")) {
bloodymess();
newmis.skin = 1;
} else {
newmis.skin = 0;
}
newmis.mass = 9999;
setorigin (newmis, (holdee.origin + '0 0 30'));
newmis.size = ('80 80 80');
// newmis.velocity = ('0 0 500');
// newmis.speed = 10;
// newmis.angles = vectoangles(newmis.velocity);
newmis.classname = "newmis";
newmis.ltime = 10;
// newmis.touch = rise_touch;
if (self.classname != "flare") {
setmodel (newmis, "models/spire.mdl");
}
newmis.think = hold_timer;
newmis.nextthink = (time + 0.01);
};

void() spire_sense = {



	local entity head, selected;
	local float dist;



        dist = 85;


	selected = world;
	head = findradius(self.origin, 85);
	while(head)
	{

                if(head.health > 0) 
		{
			if ( (vlen(head.origin - self.origin) < dist) )
			{
				selected = head;
				dist = vlen(head.origin - self.origin);
			}
		}
		head = head.chain;
	}
	if ((dist<85) && (dist>20) && (selected.classname == "player"))

        {
centerprint (selected, "This ground has been disturbed.");
}
if (dist<21) {
selected.velocity = '0 0 0';
hold(selected);
spire_rise(selected);
self.think = SUB_Remove;
self.nextthink = (time + 0.5);
} else {
	self.nextthink = 0.5;
	self.think = spire_sense;
}
};

void() spire_activate = {
// sprint (self.owner, grr);

// 	sound (self, CHAN_AUTO, "misc/basekey.wav", 1, ATTN_NORM);
      //  sprint(self.owner,"start your Zapping!\n");
   traceline ( self.origin, (self.origin - '0.00000 0.00000 250.00000'), FALSE, self);
   particle2 ( trace_endpos, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 255.00000, 10, 80.00000);
self.model = "";
self.classname = "spire_trap";
        self.nextthink=time+0.1;
        self.think=spire_sense;
};

void() spire_touch = {

self.movetype = MOVETYPE_FLY;
	setorigin (self, self.origin + '0 0 5');

        sprint(self.owner,"Spire trap set.\n");
        self.nextthink=time+3;
        self.think=spire_activate;
        return;

};

void() spire_drop = {
	local	entity missile, mpuff;
        if ((self.bluemana<8) && (self.classname == "player")) {
sprint (self, "you don't have enough mana!\n");
 return;
}
if (self.classname == "player") {
      self.magic_finished = (time + 0.5);
	self.bluemana = self.bluemana - 8;  //took out invalid syntax - rockets not subtracting
	self.punchangle_x = -2;
}
//	self.currentammo = self.ammo_rockets = self.ammo_rockets - 5;  //fix by mjmorgan@usa.net
//	sound (self, CHAN_WEAPON, "weapons/grenade.wav", 1, ATTN_NORM);


	missile = spawn ();
	missile.owner = self;
	missile.movetype = MOVETYPE_TOSS;
	missile.solid = SOLID_BBOX;
        missile.classname = "mine";

// set missile speed

	makevectors (self.v_angle);
        missile.velocity = aim2(self, 0);
	missile.velocity = missile.velocity * 0;
      //  missile.angles = vectoangles(missile.velocity);

	missile.touch = spire_touch;

// set missile duration
	setmodel (missile, "models/dwarf.mdl");
	setsize (missile, '0 0 0', '0 0 0');
	setorigin (missile, self.origin + v_forward*8 + '0 0 16');


};
