
void() bushbash_bit_wither = {
self.drawflags |= SCALE_TYPE_ZONLY;
AdvanceThinkTime(self, 0.1);
self.think = ChunkShrink;
};

void() bushbash_bit_spike = {
if (self.cnt < 3) {
self.cnt = self.cnt + 1;
sound ( self, CHAN_VOICE, "weapons/gauntht1.wav", 1.00000, ATTN_NORM);
   particle2 ( (self.origin + random('-30 -30 0', '30 30 300')), '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', random(96, 104), 2, 80.00000);
AdvanceThinkTime(self, 0.04);
self.think = bushbash_bit_spike;
} else {
AdvanceThinkTime(self, 1);
self.think = bushbash_bit_wither;
}
};

void() bushbash_bit_grow = {
if (self.scale < 1.2) {
self.scale += 0.1;
AdvanceThinkTime(self, 0.05);
self.think = bushbash_bit_grow;
} else {
AdvanceThinkTime(self, 0.05);
self.think = bushbash_bit_spike;
}
};

void() bushbash_bit = {

newmis = spawn();
newmis.solid = SOLID_NOT;
newmis.movetype = MOVETYPE_NOCLIP;
newmis.scale = 0.02;
setmodel(newmis, "models/bushbash.mdl");
newmis.origin = self.origin;
newmis.frame = random(1, 4);
newmis.angles = random('0 -180 0', '0 180 0');
AdvanceThinkTime(newmis, 0.1);
newmis.think = bushbash_bit_grow;
};

void() bushbash_bash = {
traceline (self.jones.origin , (self.jones.origin-('0 0 800')) , TRUE , self);
if ((self.jones.origin_z - trace_endpos_z) < 120) {
	T_Damage (self.jones, self, self.owner, random(60, 95));
	sound ( self.jones, CHAN_VOICE, "weapons/gauntht1.wav", 1.00000, ATTN_NORM);
	if ((self.jones.thingtype == THINGTYPE_FLESH) && (self.jones.model != "models/spider")) {
		bloodymess();
	}
}
remove(self);
};

void (entity holdee) bushbash_hold = {
newmis = spawn();
newmis.owner = self;
newmis.jones = holdee;
newmis.solid = SOLID_BBOX;
newmis.movetype = MOVETYPE_FLY;
newmis.mass = 9999;
setorigin (newmis, (holdee.origin + '0 0 30'));
setsize (newmis, '-40 -40 -40', '40 40 40');
newmis.classname = "newmis";
newmis.think = bushbash_bash;
newmis.nextthink = (time + 0.8);
};

void() bushbash_touch = {
if ((other.takedamage == DAMAGE_YES) && (other.solid != SOLID_BSP)) {
	if (other.flags & FL_ONGROUND) {
		setorigin(self, other.origin);
		} else {
	      traceline (self.origin , (self.origin-('0 0 600')) , TRUE , self);
		setorigin(self, trace_endpos);
	}
	self.velocity = '0 0 0';
	setsize(self, '-20 -20 0', '20 20 60');
	bushbash_bit();
	bushbash_bit();
	bushbash_bit();
	bushbash_bit();
	bushbash_bit();
	bushbash_bit();
	bushbash_hold(other);
}
remove(self);
};

void() bushbash_sparkle = {
   particle2 ( (self.origin + random('-30 -30 -30', '30 30 30')), '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', random(98, 108), 2, 80.00000);
AdvanceThinkTime(self, 0.1);
self.think = bushbash_sparkle;
};

void() bushbash_launch = {
if (self.level < 3) {
sprint(self, "you're not experienced enough!\n");
return;
} else {
if (self.bluemana < 15) {
sprint(self, "you don't have enough mana!\n");
return;
} else {
self.bluemana -= 15;
self.magic_finished = (time + 4);

newmis = spawn();
      makevectors (self.v_angle);

      traceline (self.origin , (self.origin+(v_forward * 55)) , FALSE , self);


      setorigin (newmis, (trace_endpos + '0 0 40'));

newmis.hull = HULL_POINT;
makevectors(self.v_angle);
newmis.owner = self;
newmis.velocity = (v_forward * 500);
newmis.angles = vectoangles(newmis.velocity); 
newmis.cnt = random(3, 10);
newmis.solid = SOLID_BBOX;
newmis.movetype = MOVETYPE_FLYMISSILE;
newmis.drawflags = MLS_ABSLIGHT;
newmis.abslight = 1;
AdvanceThinkTime(newmis, 0.1);
newmis.touch = bushbash_touch;
newmis.think = bushbash_sparkle;
}
}
};
