vector stormwind;

void() twister_dissipate = {
};

void() twister_damage = {
};

void() junker;

void() twister_twist = {
if (self.model != "models/twister.mdl") {
setmodel(self, "models/twister.mdl");
}
sound (self, CHAN_AUTO, "crusader/tornado.wav", 1, ATTN_NORM);
stormwind = random('-3 -3 0', '3 3 0');
self.velocity += stormwind;
if (self.cnt == 0) {
	if (self.frame > 122) {
		self.cnt = 1;
		junker();
	} else {
		self.frame += 1;
	}
}
if (self.cnt == 1) {
	if (self.frame > 23) {
		self.frame = 0;
	} else {
		self.frame += 1;
	}
}
if (self.lifetime == 50) {
self.cnt = 2;
self.frame = 76;
}
if (self.cnt == 2) {
	if(self.frame > 100) {
		self.cnt = 3;
	} else {
		self.frame += 1;
	}
}
if (self.cnt == 3) {
	if(self.frame > 74) {
		remove(self);
		stormwind = '0 0 0';
	} else {
		self.frame += 1;
	}
}
self.lifetime -= 1;
AdvanceThinkTime(self, 0.1);
self.think = twister_twist;
};

void() twister_drop = {
	traceline (self.origin , (self.origin-('0 0 600')) , TRUE , self);
newmis = spawn();
newmis.controller = self;
setorigin(newmis, trace_endpos);
newmis.frame = 100;
newmis.scale = 2.4;
newmis.lifetime = 200;
//setmodel(newmis, "models/twister.mdl");
newmis.solid = SOLID_NOT;
newmis.movetype = MOVETYPE_NOCLIP;
AdvanceThinkTime(newmis, 3);
newmis.think = twister_twist;
};

void()twister_cloud_minor;

void() twister_cloud_think = {
if (random(1, 20) < 10) {
particle2 ( (self.origin + random('-170 -170 -30', '170 170 0')), '-30.00000 -30.00000 -190.00000', '30.00000 30.00000 -490.00000', random(144, 159), 0, 1.00000);
}
self.velocity += stormwind;
if (self.lifetime > 0) {
	if ((self.cloudexpand == 1) && (self.scale < 2.3)) {
		self.scale += 0.1;
	} else {
		self.cloudexpand = 0;
	}
	if (self.cloudexpand == 0) {
		if (self.scale > self.nextsizey) {
			self.scale -= 0.05;
		} 
		if (self.scale < self.nextsizey) {
			self.scale += 0.05;
		}
		if ((self.scale < (self.nextsizey + 0.05)) && (self.scale > (self.nextsizey - 0.05))) {
			self.nextsizey = random(15, 23)/10;
		}
	}
	if (self.frame>29) {
		self.frame = 1;
	} else {
		self.frame += 1;
	}
	if ((random(1, 20) < 3) && (self.classname == "cloudme")) {
		twister_cloud_minor();
	}
	T_RadiusDamage (self, self.owner, 60, other);
	self.lifetime -= 1;
	AdvanceThinkTime(self, 0.1);
	self.think = twister_cloud_think;
} else {
if (self.auraV != 1) {
self.drawflags |= (DRF_TRANSLUCENT | MLS_ABSLIGHT);
self.abslight = 1.5;
self.auraV = 1;
}
	if (self.scale < 2.5) {
		self.scale += 0.05;
		self.abslight -= 0.01;
		if (self.frame>29) {
			self.frame = 1;
		} else {
			self.frame += 1;
		}
		AdvanceThinkTime(self, 0.1);
		self.think = twister_cloud_think;
	} else {
		AdvanceThinkTime(self, 0.2);
		self.think = SUB_Remove;
	}
}
};

void() twister_cloud_minor = {
local vector random_vector;
	random_vector_x = random(-400,400);
	random_vector_y = random(-400,400);
	random_vector_z = 0;
newmis = spawn();
newmis.scale = 0.1;
setorigin (newmis, (self.origin + random_vector));
setmodel (newmis, "models/cloud.mdl");
newmis.movetype = MOVETYPE_NOCLIP;
newmis.solid = SOLID_NOT;
newmis.lifetime = 30;
AdvanceThinkTime(newmis, 0.02);
newmis.think = twister_cloud_think;
};

void() junker_think = {
	local vector pull;
	local float  pull_speed;
	local entity head;
head = findradius(self.origin, 400);

while (head) {
pull = self.origin - head.origin;

if ((head.takedamage == DAMAGE_YES) && (head.solid != SOLID_BSP)) {
if ((vlen(head.origin - self.origin) < 400) ) {
			pull_speed = 0.5;
			normalize(pull);
			pull *= pull_speed;
                        if (head.flags & FL_ONGROUND) {
				head.flags ^= FL_ONGROUND;
			}
pull_z = 0;
			head.velocity += pull;
}
if ((vlen(head.origin - self.origin) < 300) ) {
			pull_speed = 1;
			normalize(pull);
			pull *= pull_speed;
                        if (head.flags & FL_ONGROUND) {
				head.flags ^= FL_ONGROUND;
			}
pull_z = 0;
			head.velocity += pull;
}
if ((vlen(head.origin - self.origin) < 200) ) {
			pull_speed = 2;
			normalize(pull);
			pull *= pull_speed;
                        if (head.flags & FL_ONGROUND) {
				head.flags ^= FL_ONGROUND;
			}
pull_z = 0;
			head.velocity += pull;

}
if ((vlen(head.origin - self.origin) < 100) ) {
                        if (head.flags & FL_ONGROUND) {
				head.flags ^= FL_ONGROUND;
			}
if (random(1, 20) < 8) {
sound ( head, CHAN_VOICE, "weapons/gauntht1.wav", 1.00000, ATTN_NORM);
if ((head.model == "models/tree2.mdl") || (head.model == "models/ntree.mdl") || (head.model == "models/tree.mdl") || (head.classname == "ntreetop") || (head.classname == "tree2top")) {
	T_Damage (head, self, self.owner, random(700, 1000));
}
	T_Damage (head, self, self.owner, random(25, 50));

}
			head.velocity += '0 0 600';
}
}
head = head.chain;
}
if (self.lifetime > 0) {
setorigin(self, self.owner.origin);
particle2 ( (self.origin + random('-30 -30 0', '30 30 100')), '-30.00000 -30.00000 50.00000', '30.00000 30.00000 150.00000', random(15, 25), 7, 50.00000);
particle2 ( (self.origin + random('-30 -30 0', '30 30 100')), '-30.00000 -30.00000 25.00000', '30.00000 30.00000 50.00000', random(15, 25), 2, 50.00000);

self.lifetime -= 1;
AdvanceThinkTime(self, 0.1);
self.think = junker_think;
} else {
remove(self);
}
};

void() junker = {
newmis = spawn();
newmis.owner = self;
setorigin (newmis, self.origin);
newmis.scale = 1.7;
newmis.movetype = MOVETYPE_NOCLIP;
newmis.solid = SOLID_NOT;
newmis.lifetime = 155;
AdvanceThinkTime(newmis, 0.02);
newmis.think = junker_think;

};

void() twister_cloud = {
self.cnt = 0;
setmodel(self, "models/cloud.mdl");
self.velocity = '0 0 0';
self.lifetime = 200;
self.classname = "cloudme";
twister_drop();
self.movetype = MOVETYPE_NOCLIP;
AdvanceThinkTime(self, 0.02);
self.think = twister_cloud_think;
};

void() twister_launch_think = {
if (self.cnt > 30) {
self.movetype = MOVETYPE_NOCLIP;
	traceline (self.origin , (self.origin-('0 0 600')) , TRUE , self);
	setorigin(self, trace_endpos);

	traceline (self.origin , (self.origin+('0 0 600')) , TRUE , self);
	setorigin(self, (trace_endpos - '0 0 30'));
	AdvanceThinkTime(self, 0.05);
	self.think = twister_cloud;
} else {
particle2 ( (self.origin + random('-30 -30 0', '30 30 300')), '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', random(96, 104), 15, 80.00000);
self.cnt += 1;
AdvanceThinkTime(self, 0.05);
self.think = twister_launch_think;
}
};

void() twister_launch = {
if (self.level < 6) {
sprint (self, "you're not experienced enough!\n");
return;
}
if (self.bluemana < 35) {
sprint (self, "you don't have enough mana to cast Tornado!\n");
return;
}
self.bluemana -= 35;
self.magic_finished = (time + 5);
newmis = spawn();
setorigin(newmis, (self.origin + '0 0 40'));
newmis.hull = HULL_POINT;
newmis.solid = SOLID_NOT;
newmis.movetype = MOVETYPE_FLY;
makevectors(self.v_angle);
newmis.velocity = (v_forward * 200);
AdvanceThinkTime(newmis, 0.1);
newmis.think = twister_launch_think;
};
