void()CrashFlash;
void() flare_rings_wipe =
{
if (self.scale<2.5) {
self.scale += 0.2;
T_RadiusDamage (self, self.owner, (self.scale * 200), other);
AdvanceThinkTime(self, 0.02);
self.think = flare_rings_wipe;
} else {
remove(self);
}

};
void() flare_rings =
{
newmis = spawn();
   newmis.effects = EF_BRIGHTLIGHT;
setorigin(newmis, self.origin);
newmis.movetype = MOVETYPE_NONE;
newmis.solid = SOLID_NOT;
newmis.scale = 0.02;
setmodel(newmis, "models/expring.mdl");
newmis.drawflags |= ((MLS_ABSLIGHT) | (DRF_TRANSLUCENT));
newmis.abslight = 1.5;
 sound (newmis, CHAN_WEAPON, "exp3.wav", 1, ATTN_NORM);
AdvanceThinkTime(newmis, 0.02);
newmis.think = flare_rings_wipe;

};

void() flare_wipe =
{
if (self.scale<2.5) {
self.scale += 0.1;
T_RadiusDamage (self, self.owner, (self.scale * 200), other);
AdvanceThinkTime(self, 0.02);
self.think = flare_wipe;
} else {
remove(self);
}
};

void() flare_blast =
{
newmis = spawn();
   newmis.effects = EF_BRIGHTLIGHT;
setorigin(newmis, self.origin);
newmis.movetype = MOVETYPE_NONE;
newmis.solid = SOLID_NOT;
newmis.scale = 0.02;
setmodel(newmis, "models/nukeball.mdl");
newmis.drawflags |= ((MLS_ABSLIGHT) | (DRF_TRANSLUCENT));
newmis.abslight = 1.5;
 sound (newmis, CHAN_WEAPON, "exp3.wav", 1, ATTN_NORM);
AdvanceThinkTime(newmis, 0.02);
newmis.think = flare_wipe;
};

void() flare_booms =
{
};

void() flare_build =
{
if (self.model != "models/star2.mdl") {
self.flags ^= FL_ONGROUND;
self.movetype = MOVETYPE_FLY;
self.scale = 2.5;
self.origin += '0 0 80';
self.drawflags |= ((MLS_ABSLIGHT) | (DRF_TRANSLUCENT));
self.abslight = 2;
self.avelocity = '300 300 300';
setmodel(self, "models/star2.mdl");
}
if (self.scale>0.05) {
self.scale -= 0.04;
AdvanceThinkTime(self, 0.02);
self.think = flare_build;
} else {
CrashFlash();
AdvanceThinkTime(self, 0.02);
self.think = GasserThink;
}

};

void() flare_drop_think = {
if (self.cnt < 20) {
self.cnt += 1;
particle2 ( (self.origin + random('-30 -30 0', '30 30 100')), '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', random(128, 143), 2, 80.00000);
AdvanceThinkTime(self, 0.1);
self.think = flare_drop_think;
} else {
//traceline (self.origin , (self.origin-('0 0 600')) , TRUE , self);
//setorigin(self, trace_endpos);
self.cnt = random(15, 20);
self.velocity = '0 0 0';
AdvanceThinkTime(self, 0.02);
self.think = flare_build;
}
};

void ()flare_drop =
{

if (self.level < 6) {
sprint (self, "you're not experienced enough!\n");
return;
}
if (self.bluemana < 40) {
sprint (self, "you don't have enough mana to cast Giga Flare!\n");
return;
}
self.bluemana -= 40;
self.magic_finished = (time + 5);

newmis = spawn();
newmis.classname = "flare";
newmis.hull = HULL_POINT;
setorigin (newmis, (self.origin + '0 0 40'));
newmis.solid = SOLID_NOT;
newmis.scale = 0.2;
newmis.movetype = MOVETYPE_FLY;
makevectors(self.v_angle);
newmis.velocity = (v_forward * 200);
newmis.think = flare_drop_think;
newmis.nextthink = (time + 0.02);

};

