void() blaze_touch;
void() FireWaveThink;

void() balloffire_fragments = {

newmis = spawn();
makevectors(self.angles);
setorigin(newmis, (self.origin + random('-30 -30 -30', '30 30 30')));
newmis.velocity = ((v_forward * 500) + random('-20 -20 0', '20 20 40'));  

setmodel (newmis, "models/flame1.mdl"); 
newmis.solid = SOLID_BBOX;
newmis.movetype = MOVETYPE_TOSS;
newmis.drawflags = MLS_ABSLIGHT;
newmis.abslight = 1.00000;
newmis.effects = newmis.effects | EF_DIMLIGHT; 
newmis.angles = vectoangles(newmis.velocity);

newmis.classname = "balloffirefrag";

AdvanceThinkTime(newmis, 0.2);
newmis.touch = blaze_touch;
newmis.think = FireWaveThink;
};

void() balloffire_crash = {
if (other == self.owner) {
return;
}
	if (other.movetype == MOVETYPE_FLYMISSILE || other.movetype == MOVETYPE_BOUNCEMISSILE)
		return;

balloffire_fragments();
balloffire_fragments();
balloffire_fragments();
balloffire_fragments();
balloffire_fragments();
balloffire_fragments();
sound (newmis, CHAN_WEAPON, "raven/littorch.wav", 1, ATTN_NORM); 
T_RadiusDamage ( self, self.owner, random(44.00000,66.00000), other);
gat = 1;
littlelavamess();

   WriteByte ( MSG_BROADCAST, SVC_TEMPENTITY);
   WriteByte ( MSG_BROADCAST, TE_EXPLOSION);
   WriteCoord ( MSG_BROADCAST, self.origin_x);
   WriteCoord ( MSG_BROADCAST, self.origin_y);
   WriteCoord ( MSG_BROADCAST, self.origin_z);
remove(self);
};

void() balloffire_fly = {
if (random(1, 10) < 6) {
  particle2 ( self.origin, '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', 140.00000, 16, 10.00000);
}
if (self.skin > 1) {
self.skin = 0;
} else {
self.skin += 1;
}
AdvanceThinkTime(self, 0.2);
self.think = balloffire_fly;
};

void() balloffire_launch = {

newmis = spawn();
self.magic_finished = (time + 3);
//setorigin(newmis, ((self.origin + self.proj_ofs) + (v_forward * 24.00000)));
      makevectors (self.v_angle);

      traceline (self.origin , (self.origin+(v_forward * 55)) , FALSE , self);


      setorigin (newmis, (trace_endpos + '0 0 40'));

setmodel(newmis, "models/fball1.mdl");
newmis.hull = HULL_POINT;
makevectors(self.v_angle);
newmis.owner = self;
newmis.velocity = (v_forward * 500);
newmis.angles = vectoangles(newmis.velocity); 
newmis.cnt = random(3, 10);
newmis.solid = SOLID_BBOX;
newmis.movetype = MOVETYPE_FLYMISSILE;
newmis.drawflags = MLS_ABSLIGHT;
newmis.abslight = 1;
newmis.touch = balloffire_crash;
AdvanceThinkTime(newmis, 0.1);
newmis.think = balloffire_fly;
};
