
void() ChunkShrink;

vector tsunami_left;
vector tsunami_right;

void() tsunami_rubble_touch = {
if (other.takedamage == DAMAGE_YES) {
sound ( self, CHAN_AUTO, "weapons/gauntht1.wav", 1.00000, ATTN_NORM);
if ((other.model == "models/tree2.mdl") || (other.model == "models/ntree.mdl") || (other.model == "models/tree.mdl") || (other.classname == "ntreetop") || (other.classname == "tree2top")) {
	T_Damage (other, self, self.owner, random(700, 1000));
}
if (self.model == "models/tree2.mdl") {
	T_Damage (other, self, self.owner, random(15, 45));
}
if (self.model == "models/cart.mdl") {
	T_Damage (other, self, self.owner, random(5, 15));
}
if (self.model == "models/chair.mdl") {
	T_Damage (other, self, self.owner, random(3, 9));
}
if (self.model == "models/stool.mdl") {
	T_Damage (other, self, self.owner, random(3, 9));
}
if (self.model == "models/bench.mdl") {
	T_Damage (other, self, self.owner, random(5, 15));
}
} else {
AdvanceThinkTime(self, 0.02);
self.think = ChunkRemove;
}
};

void() tsunami_rubble = {
newmis = spawn();
if (random(1, 20) < 4) {
//setorigin(newmis, (self.origin + random('-200 -200 0', '200 200 200')));
setorigin(newmis, (self.origin + random('-200 -200 5', '200 200 70')));

} else {
//setorigin(newmis, random((tsunami_left + random('0 0 0', differencia)), (tsunami_right + random('0 0 0', differencia))));
setorigin(newmis, random(tsunami_left, tsunami_right));
newmis.origin_z += (differencia_z / 4);
}
newmis.scale = random(0.9, 1.4);
newmis.auraV = random(1, 5);
if (newmis.auraV < 6) {
	setmodel(newmis, "models/chair.mdl");
	setsize(newmis, '-5 -5 0', '5 5 10');
}
if (newmis.auraV < 5) {
	setmodel(newmis, "models/stool.mdl");
	setsize(newmis, '-5 -5 0', '5 5 10');

}
if (newmis.auraV < 4) {
	setmodel(newmis, "models/bench.mdl");
	setsize(newmis, '-10 -10 0', '10 10 20');

}
if (newmis.auraV < 3) {
	setmodel(newmis, "models/cart.mdl");
	setsize(newmis, '-20 -20 0', '20 20 40');

}
if (newmis.auraV < 2) {
	setmodel(newmis, "models/tree2.mdl");
	setsize(newmis, '-60 -60 0', '60 60 120');

}

newmis.touch = tsunami_rubble_touch;
newmis.movetype = MOVETYPE_FLY;
newmis.solid = SOLID_PHASE;
makevectors(self.angles);
newmis.velocity -= (v_forward * 600);
newmis.avelocity = random('-200 -200 -200', '200 200 200');
AdvanceThinkTime(newmis, 4);
newmis.think = ChunkShrink;

};

void() tsunami_rubble_spawner = {
};

void() tsunami_washer_touch = {
if ((other.takedamage == DAMAGE_YES) && ((other.model != "models/tree2.mdl") || (other.model != "models/ntree.mdl") || (other.model != "models/tree.mdl") || (other.classname != "ntreetop") || (other.classname != "tree2top"))) {
	T_Damage (other, self, self.owner, random(1, 5));
setorigin(other, (other.origin + random('0 0 1', '0 0 10')));
}
};

void() tsunami_washer_think = {
if (self.cnt < 40) {
self.cnt += 1;
if (random(1, 20) < 4) {
 sound (self, CHAN_AUTO, "ambience/water.wav", 1, ATTN_NORM);
}
T_RadiusDamage (self, other, 60, self.owner);
AdvanceThinkTime(self, 0.1);
self.think = tsunami_washer_think;
} else {
AdvanceThinkTime(self, 0.1);
self.think = ChunkShrink;
}
};



void() tsunami_washer = {
newmis = spawn();

if (random(1, 20) < 4) {
setorigin(newmis, (self.origin + random('-200 -200 0', differencia)));
} else {
if (self.auraT == 0) {
differencia_z += random(10, 45);
} else {
differencia_z -= random(10, 45);
}
setorigin(newmis, random((tsunami_left + random('0 0 0', differencia)), (tsunami_right + random('0 0 0', differencia))));
}
newmis.skin = 2;
newmis.scale = random(1.7, 2.5);
newmis.drawflags |= (DRF_TRANSLUCENT | MLS_ABSLIGHT);
newmis.abslight = 1.5;
setmodel(newmis, "models/cloud.mdl");
newmis.movetype = MOVETYPE_NOCLIP;
newmis.solid = SOLID_NOT;
makevectors(self.angles);
newmis.velocity -= (v_forward * 600);
newmis.avelocity = random('0 -200 0', '0 200 0');
AdvanceThinkTime(newmis, 0.02);
newmis.think = tsunami_washer_think;
};

void() tsunami_washing = {
if (self.cnt > 0) {
self.cnt -= 1;
if (self.cnt == 6) {
self.auraT = 1;
}
tsunami_washer();
tsunami_rubble();
AdvanceThinkTime(self, 0.1);
self.think = tsunami_washing;
} else {
remove(self);
}
};

void() tsunami_test = {

makevectors(self.angles);

	traceline (self.origin , (self.origin-('0 0 600')) , TRUE , self);
	setorigin (self, trace_endpos);

	traceline (self.origin , (self.origin-(v_right * 300)) , TRUE , self);
tsunami_left = trace_endpos;
	traceline (self.origin , (self.origin+(v_right * 300)) , TRUE , self);
tsunami_right = trace_endpos;

	traceline (tsunami_left , (tsunami_left+(v_forward * 400)) , TRUE , self);
tsunami_left = trace_endpos-(v_forward * 65);

	traceline (tsunami_right , (tsunami_right+(v_forward * 400)) , TRUE , self);
tsunami_right = trace_endpos-(v_forward * 65);

	traceline (self.origin , (self.origin+(v_forward * 400)) , TRUE , self);
	setorigin (self, (trace_endpos - (v_forward * 80)));
differencia = '0 0 0';

AdvanceThinkTime(self, 0.02);
self.think = tsunami_washing;
};

void() tsunami_launch_think = {
if (self.cnt > 30) {
self.cnt = 15;
self.movetype = MOVETYPE_NOCLIP;
	AdvanceThinkTime(self, 0.05);
	self.think = tsunami_test;
} else {
particle2 ( (self.origin + random('-30 -30 0', '30 30 300')), '-30.00000 -30.00000 50.00000', '30.00000 30.00000 100.00000', random(96, 104), 15, 80.00000);
self.cnt += 1;
AdvanceThinkTime(self, 0.05);
self.think = tsunami_launch_think;
}
};

void() tsunami_launch = {

if (self.level < 6) {
sprint (self, "you're not experienced enough!\n");
return;
}
if (self.bluemana < 35) {
sprint (self, "you don't have enough mana to cast Tsunami!\n");
return;
}
self.bluemana -= 35;
self.magic_finished = (time + 5);


newmis = spawn();
setorigin(newmis, (self.origin + '0 0 40'));
newmis.hull = HULL_POINT;
newmis.solid = SOLID_NOT;
newmis.movetype = MOVETYPE_FLY;
makevectors(self.v_angle);
newmis.velocity = (v_forward * 200);
newmis.velocity_z = 0;
newmis.angles = vectoangles(newmis.velocity); 
AdvanceThinkTime(newmis, 0.1);
newmis.think = tsunami_launch_think;

};